#include <stdio.h>
/* ciao.c : file sorgente di un programma che effettua qualche
            semplicissima prova di utilizzo di una stringa di
            caratteri allo scopo di chiarire che essi possono essere
            gestiti come degli interi */
int main()
{
  int i;
  char scritta[10];
  /* Inizializzazione della stringa */
  scritta[0]=0143;  // Codice ASCII in ottale (=99) della lettera c
  scritta[1]=0151;  // Codice ASCII in ottale (=105) della lettera i
  scritta[2]=0141;  // Codice ASCII in ottale (=97) della lettera a
  scritta[3]=0157;  // Codice ASCII in ottale (=111) della lettera o
  scritta[4]=041;   // Codice ASCII in ottale (=33) del carattere !
  scritta[5]=0;     // Codice ASCII del carattere NUL che termina la stringa
  /* Stampiamo la scritta sul terminale per verificare che sia proprio:
     ciao! */
  printf("%s\n",scritta);
  /* Passiamo dal minuscolo al maiuscolo */
  for(i=0; i<strlen(scritta); i++) {
    if( scritta[i] >= 0141 && scritta[i] <= 0172 )
      scritta[i] -= 040;
  }
  /* Stampiamo la scritta sul terminale per verificare che sia proprio:
     CIAO! */
  printf("  ... Forse non sono stato chiaro; ripeto:\n");
  printf("%s\n",scritta);
  /* Adesso ci chiediamo se e' proprio vero che il primo elemento del
     vettore uguale a 0 termina la stringa.
     Per verificarlo inizializziamo altri elementi in coda al vettore
     scritta e poi stampiamo la lunghezza della stringa scritta */
  scritta[6]=0141;  // Codice ASCII in ottale (=97) della lettera a
  scritta[7]=0141;  // Codice ASCII in ottale (=97) della lettera a
  scritta[8]=0141;  // Codice ASCII in ottale (=97) della lettera a
  scritta[9]=0;     // Codice ASCII del carattere NUL che termina la stringa
  /* Stampiamo la lunghezza della scritta sul terminale per verificare che
     sia proprio: 5 */
  printf("  Il numero di caratteri che formano");
  printf(" la scritta precedente e': %d\n",strlen(scritta));
  printf("  ... Se la cosa non ti sorprende guarda");
  printf(" il file sorgente del programma\n");
  exit(0);
}
