#include <stdio.h>
/* nomi_stringhe.c : file sorgente di un programma che effettua alcune
                     manipolazioni su una stringa formata da un nome e
                     da un cognome. Le operazioni sulle stringhe di
                     caratteri sono effettuate facendo ricorso il piu'
                     possibile a funzioni predefinite in libreria,
                     allo scopo di aumentare la propria familiarita'
		     con queste funzioni di libreria */
/* ### */
/* La prossima definizione consente di cambiare facilmente la
   lunghezza massima dei nomi e dei cognomi */
#define LUNGMAX 25
/* Definizione dei prototipi delle funzioni */
void elimina_trattino(char scritta[]);
void maiusc(char scritta[]);
void minusc(char scritta[]);
void riempi_di_spazi(char scritta[]);
void trattino_maiusc(char scritta[]);
/* ### */
int main()
{
  int lung;
  char scrittainiz[2*LUNGMAX], scrittafin[2*LUNGMAX];
  char nome[LUNGMAX], cognome[LUNGMAX];
  char *puntatore;
  printf("  Scrivimi il nome e il cognome (per favore, solo uno spazio\n");
  printf("  in tutta la scritta e usalo per separare il nome dal cognome;\n");
  printf("  se hai un nome o un cognome composto, usa il carattere _ al\n");
  printf("  posto dello spazio per separarne le parti, ad es. scrivi\n");
  printf("  'anna_maria' anziche' 'anna maria')\n");
  /* Input della scritta iniziale (composta da un nome e da un cognome)
     utilizzando l'istruzione fgets (piu' sicura) o gets */

  /* Assegnamo alla variabile lung la lunghezza della stringa
     scrittainiz (conviene utilizzare la funzione strlen) */

  /* L'ultimo carattere di scrittainiz e' un LF (=va alla riga
     successiva), e' meglio eliminarlo ponendo uno 0 (cioe' il
     carattere NUL) al suo posto;
     si ricordi che il carattere LF e' in scrittainiz[lung-1] */

  /* Troviamo l'indirizzo di memoria corrispondente al carattere ' '
     che separa il nome dal cognome:
     assegnamo alla variabile puntatore l'indirizzo di memoria
     corrispondente (conviene utilizzare la funzione strchr) */

  /* Poniamo uguale a 0 (cioe' il carattere NUL) il valore del
     carattere che si trova nell'indirizzo di memoria a cui si
     riferisce puntatore */

  /* Copiamo nella stringa nome la parte di stringa contenuta in
     scrittainiz fino al primo carattere NUL (conviene utilizzare la
     funzione strcpy) */

  /* Riempiamo la stringa nome con degli spazi */

  /* Facciamo diventare minuscole tutte le lettere del nome */

  /* Mettiamo le maiuscole alla prima lettera del nome e ad ogni lettera
     che segue un trattino del tipo '_' */

  /* Incrementiamo di 1 l'indirizzo di memoria associato a puntatore */

  /* Copiamo nella stringa cognome la parte di stringa contenuta in
     scrittainiz a partire dall'indirizzo di memoria in puntatore fino
     al secondo carattere NUL (conviene utilizzare la funzione
     strcpy) */

  /* Riempiamo la stringa cognome con degli spazi */

  /* Facciamo diventare maiuscole tutte le lettere del cognome */

  /* Copiamo il cognome nella stringa scrittafin (conviene utilizzare
     la funzione strcpy) */

  /* Copiamo il nome in coda alla stringa scrittafin (conviene
     utilizzare la funzione strcat) */

  /* Sostituisco tutti i trattini che compaiono nella stringa scrittafin
     con degli spazi */

  /* Messaggi finali di output */
  printf("\n  Riscrivo cognome e nome in un formato che spero ti piaccia:\n");
  printf("%s\n", scrittafin);
  exit(0);
}
/* ### */
void elimina_trattino(scritta)
     char scritta[];
     /* Nota: questa function mette il carattere ' ' al posto di ogni
	      carattere '_' nella stringa scritta.
	      Esempio: 'Giovanni_Battista' deve diventare
	      'Giovanni Battista' al termine della function. */
{
  char *puntatore;
  /* Cerchiamo la prima occorrenza del carattere '_' nella
     stringa scritta a partire dalla posizione iniziale:
     assegnamo alla variabile puntatore l'indirizzo di memoria
     corrispondente (conviene utilizzare la funzione strchr) */

  /* Mentre e' verificata la condizione che il valore di puntatore sia
     diverso da NULL, continuiamo ad eseguire il ciclo di istruzioni
     che sono comprese tra le seguenti parentesi {} */

  {
    /* Poniamo uguale allo spazio il carattere che si trova
       nell'indirizzo di memoria a cui si riferisce puntatore */

    /* Incrementiamo di 1 l'indirizzo di memoria associato a puntatore */

    /* Cerchiamo la prossima occorrenza del carattere '_' nella
       stringa scritta a partire dall'indirizzo di memoria
       corrispondente a puntatore:
       assegnamo ancora alla variabile puntatore l'indirizzo di memoria
       corrispondente (conviene utilizzare la funzione strchr) */

  }
  /* Uscita dalla funzione */
  return;
}
/* ### */
void maiusc(scritta)
     char scritta[];
{
  int i;
  /* Eseguiamo un ciclo su i che va da 0 alla lunghezza di scritta
     (conviene utilizzare la funzione strlen) */

  {
    /* Se scritta[i] e' una lettera minuscola, mettiamo la maiuscola al
       suo posto, utilizzando la funzione toupper */

  }
}
/* ### */
void minusc(scritta)
     char scritta[];
{
  int i;
  /* Eseguiamo un ciclo su i che va da 0 alla lunghezza di scritta
     (conviene utilizzare la funzione strlen) */

  {
    /* Se scritta[i] e' una lettera maiuscola, mettiamo la minuscola al
       suo posto, utilizzando la funzione tolower */

  }
}
/* ### */
void riempi_di_spazi(scritta)
     char scritta[];
{
  int i;
  /* Ciclo su i che va dalla lunghezza di scritta (conviene utilizzare
     la funzione strlen) a LUNGMAX-2 */

  {
    /* Poniamo l'i-esimo carattere di scritta uguale a Space (=' ') */

  }
  /* Poniamo l'ultimo carattere di scritta (cioe' quello di posto
     LUNGMAX-1) uguale a NUL */

}
/* ### */
void trattino_maiusc(scritta)
     char scritta[];
     /* Nota: questa function mette il carattere maiuscolo al posto del
	      minuscolo all'inizio della scritta e dopo ogni carattere '_'.
	      Esempio: 'giovanni_battista' deve diventare
	      'Giovanni_Battista' al termine della function. */
{
  char *puntatore;
  /* Facciamo diventare maiuscolo il primo carattere di scritta,
     utilizzando la funzione toupper */

  /* Cerchiamo la prima occorrenza del carattere '_' nella
     stringa scritta a partire dalla posizione iniziale:
     assegnamo alla variabile puntatore l'indirizzo di memoria
     corrispondente (conviene utilizzare la funzione strchr) */

  /* Mentre e' verificata la condizione che il valore di puntatore sia
     diverso da NULL, continuiamo ad eseguire il ciclo di istruzioni
     che sono comprese tra le seguenti parentesi {} */

  {
    /* Incrementiamo di 1 l'indirizzo di memoria associato a puntatore */

    /* Facciamo diventare maiuscolo il carattere che si trova
       nell'indirizzo di memoria a cui si riferisce puntatore
       (conviene utilizzare la funzione toupper) */

    /* Cerchiamo la prossima occorrenza del carattere '_' nella
       stringa scritta a partire dall'indirizzo di memoria
       corrispondente a puntatore: assegnamo ancora alla variabile
       puntatore l'indirizzo di memoria corrispondente (conviene
       utilizzare la funzione strchr) */

  }
  /* Uscita dalla funzione */
  return;
}
