#include<stdio.h>
#include<math.h>
/* max_virg_mob.c: file sorgente di un programma che permette di
                   determinare (per tentativi) quale e' il massimo
		   numero rappresentabile tra quelli in virgola mobile
                   del tipo TIPOVM (vedi sotto per la definizione di
		   TIPOVM) */
/* ### */
/* La prossima definizione consente di cambiare facilmente il tipo di
   numeri con cui si effettua il calcolo (da double a float o il
   viceversa oppure da double ad altri tipi) */
#define TIPOVM double
/* Attenzione!
   Se si vuole utilizzare il tipo float anziche' il tipo double bisogna
   togliere le l dai formati di conversione (cioe' occorre utilizzare
   f o e anziche' lf o le, rispettivamente).
   Se si vuole utilizzare il tipo long double anziche' il tipo double
   bisogna sostituire le l con delle L nei formati di conversione (cioe'
   occorre utilizzare Lf o Le anziche' lf o le, rispettivamente). */
/* ### */
int main()
{
  int j, maxesp, lungmant;
  TIPOVM a = 1.;
  printf("Massimo esponente? ");
  scanf("%d",&maxesp);
  printf("Lunghezza mantissa? ");
  scanf("%d",&lungmant);
  for(j=1;j<=maxesp;j++) {
    a *= 2.;
  }
  a *= ((TIPOVM) 2. - (pow((TIPOVM) 0.5,lungmant)));
  printf(" ( 2 - 2^-%d ) * 2^%d = %24.17le\n", lungmant, maxesp, a);
}
