#include <stdio.h>
/* trig_iter.c : file sorgente di un programma che calcola in modo
                 iterativo l'espansione di cos(nx) e sen(nx) in
                 funzione delle potenze di cos x e sen x */
/* ### */
/* La prossima definizione consente di cambiare facilmente il
   coefficiente intero n massimo delle funzioni cos(nx) e sen(nx) di
   cui vogliamo calcolare gli sviluppi */
#define NMAX 25
/* Definizione dei prototipi delle funzioni */
void cossenn(int cosi[], int seni[], int n);
void stampasvil(int svil[], int n);
/* ### */
int main()
{
  /* Definizione delle variabili:
     n = coefficiente intero di cos(nx) e sen(nx)
     cosn = vettore di coefficienti interi che rappresenta
            lo sviluppo delle funzioni cos(nx)
     senn = vettore di coefficienti interi che rappresenta
            lo sviluppo delle funzioni sen(nx) */
  int n, cosn[NMAX+1], senn[NMAX+1];
  /* Fase di input del coefficiente intero n */


  /* Calcoliamo simultaneamente gli sviluppi di cos(nx) e sen(nx) */

  /* Stampiamo "cos nx =  " */

  /* Stampiamo lo sviluppo descritto dal vettore cosn */

  /* Stampiamo "sen nx =  " */

  /* Stampiamo lo sviluppo descritto dal vettore senn */

  exit(0);
}
/* ### */
void cossenn(cosi, seni, n)
     int cosi[];
     int seni[];
     int n;
    /* Nota: questa function e' stata scritta in modo tale che il
             calcolo dello sviluppo di cos(nx) e sen(nx) sia
             iterativo */
{
  /* Definizione di due contatori i e j */
  int i, j;
  /* Definizione di cosimen1 e senimen1 che sono dei vettori di al
     piu' n coefficienti interi che rappresentano lo sviluppo delle
     funzioni cos((i-1)x) o sen((i-1)x) (con i che varia da 2 a n) */
  int cosimen1[NMAX], senimen1[NMAX];
  /* Definisco i valori iniziali dell'iterazione, cioe' gli sviluppi di
     cos(ix) e sen(ix) quando i=1:
     scriviamo nel vettore cosi lo sviluppo di cos(x) ... */


  /* ... E scriviamo nel vettore seni lo sviluppo di sen(x) */


  /* Eseguiamo un ciclo sul contatore i che va da 2 a n in modo da
     calcolare gli sviluppi di cos(ix) e sen(ix) una volta noti
     quelli di cos((i-1)x) e sen((i-1)x) */

  {
    /* Copio in cosimen1 lo sviluppo rappresentato nel vettore cosi */


    /* Copio in senimen1 lo sviluppo rappresentato nel vettore seni */


    /* Azzero lo sviluppo rappresentato nel vettore cosi */


    /* Eseguiamo un ciclo sul contatore j che va da 0 a i-1 in modo da
       riportare nel vettore cosi il prodotto di cos(x)*cos((i-1)x) */


    /* Eseguiamo un ciclo sul contatore j che va da 1 a i in modo da
       aggiungere allo sviluppo precedente nel vettore cosi il
       prodotto di -sen(x)*sen((i-1)x) */


    /* Azzero lo sviluppo rappresentato nel vettore seni */


    /* Eseguiamo un ciclo sul contatore j che va da 1 a i in modo da
       riportare nel vettore seni il prodotto di sen(x)*cos((i-1)x) */


    /* Eseguiamo un ciclo sul contatore j che va da 0 a i-1 in modo da
       aggiungere allo sviluppo precedente nel vettore seni il
       prodotto di cos(x)*sen((i-1)x) */


  }
  /* Uscita dalla funzione */
  return;
}
/* ### */
void stampasvil(svil, n)
     int svil[];
     int n;
{
  /* Definizione di un contatore i */
  int i;
  /* Definizione di una variabile intera nscritti che conta il numero
     di termini scritti dell'espansione */
  int nscritti;
  /* Azzero nscritti */

  /* Ciclo su i che va da 0 a n per scrivere tutti i termini dello
     sviluppo */

  {
    /* Stampiamo un termine solo se svil[i] e' diverso da zero */

    {
      /* Ogni 2 termini scritti dell'espansione stampiamo un ritorno a capo
	 e qualche spazio */


      /* Se nscritti>0 e svil[i]>0 stampiamo il segno + */


      /* Stampiamo l'i-esimo coefficiente dello sviluppo */

      /* Se i<n stampiamo cos^n-i x */


      /* Se i>0 stampiamo sen^i x */


      /* Se il termine che abbiamo stampato non e' l'ultimo della riga
	 stampiamo uno spazio per separare un termine rispetto
	 all'altro */


      /* Incrementiamo il numero di termini scritti */

    }
  }
  /* Stampa il ritorno a capo */

  return;
}
